#include "FastLED.h" //подключаем библиотеку FastLED 
#include <OneWire.h> //подключаем библиотеку OneWire
#include <DallasTemperature.h> //подключаем библиотеку Arduino-Temperature-Control-Library
#define ONE_WIRE_BUS 12 // датчик DS18B20 подключён к вывпду D12 Arduino
#define NUM_LEDS 15 // управляем 15-ю светодиодами WS2812B
#define DATA_PIN 3 // первый светодиод WS2812B подключён к выводу D3 Arduino 
OneWire oneWire(ONE_WIRE_BUS); //настройка библиотеки
uint8_t temp = 0; //переменная где будет храниться значение температуры
DallasTemperature sensors(&oneWire); //настройка библиотеки
CRGB leds[NUM_LEDS]; //массив из 15 светодиодов WS2812B
//t[15][3] массив в котором задаётся цвет свечения светодиодов
const uint8_t t[15][3]  = {{0,0,255}, {0,0,255}, {0,0,255}, {0,200,0}, {0,200,0}, {0,200,0}, {0,200,0}, {0,200,0}, {0,200,0}, {0,200,0}, {200,0,0}, {200,0,0}, {200,0,0}, {200,0,0}, {200,0,0}};
void clearALL() { //функция гашения раннее включённых светодиодов
  for (int i = 0; i < NUM_LEDS; i++) {
    leds[i] = CRGB(0, 0, 0);
  }
}
void setup() {
  delay(1000);
  FastLED.addLeds<WS2812B, DATA_PIN, GRB>(leds, NUM_LEDS);//настройка библиотеки
  analogWrite(9, 25);//на выводе D9 формируется ШИ сигнал для управления питанием св. ленты подсветки шкалы
  sensors.begin();//настройка библиотеки
  delay(500);
  for (uint8_t i = 0; i < NUM_LEDS; i++) { //последовательное включение и выключение светодиодов для их проверки
    leds[i] = CRGB(0, 200, 0); 
    FastLED.show();
    delay(250);
    leds[i] = CRGB(0, 0, 0); 
    leds[i] = CRGB(150, 0, 0); 
    FastLED.show();
    delay(250);
    leds[i] = CRGB(0, 0, 0);
    leds[i] = CRGB(0, 0, 255);
    FastLED.show();
    delay(250);
    leds[i] = CRGB(0, 0, 0);
    FastLED.show();
  }
}
void loop() {
  sensors.requestTemperatures();//опрос датчика температуры
  temp = sensors.getTempCByIndex(0);//получение значения температуры с датчика
  clearALL();//гашение ранеее включённых светодиодов
  if(temp < 15) {leds[0] = CRGB(0, 150, 255);}//настройка цвета свечения первого светодиода при t<15°С
  if(temp > 29) {leds[14] = CRGB(200, 0, 200);} //настройка цвета свечения последнего светодиода при t>29°С
  //при 14>t<30 выбирается цвет из массива t, а спомощью функции map преобразовуется значение температуры в значения ключей массива t
  else {temp = map(temp, 15, 29, 0, 14); leds[temp] = CRGB(t[temp][0], t[temp][1], t[temp][2]);}
  FastLED.show();//обработка данных библиотекой
  delay(10000);//пауза между измерениями ~10 секунд
}
